package com.example.copiarfichero_fx.Vista;

import com.example.copiarfichero_fx.Modelo.CopiarFichero;

import java.awt.EventQueue;


import javax.swing.JFrame;
import javax.swing.JProgressBar;
import java.awt.TextField;
import java.io.*;
import javax.swing.JButton;
import javax.swing.JLabel;

import java.awt.Color;
import java.awt.Font;


public class Vista {

    private CopiarFichero copiarFichero;

    private JFrame frame;
    private TextField tfArchivoOrigen;
    private TextField tfArchivoDestino;
    private JButton btnBotonCopia;
    private JProgressBar pbBarraProgreso;
    private JLabel lblComprobacion;

    public Vista() {
        empezar();
    }

    public void empezar(){
        try {
            cargarVista();
            frame.setVisible(true);
            btnBotonCopia.addActionListener(e -> {
                try {
                    pbBarraProgreso.setValue(0);
                    cargarDatos();
                    copiarFichero.hacerCopia(pbBarraProgreso,lblComprobacion);
                } catch (IOException ex) {
                    throw new RuntimeException(ex);
                }
            });
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    public void cargarDatos(){
        File ficheroOrigen = new File(tfArchivoOrigen.getText());
        File ficheroDestino = new File(tfArchivoDestino.getText());
        try{
            FileInputStream fisCopiar = new FileInputStream(ficheroOrigen);
            FileOutputStream fosPegar = new FileOutputStream(ficheroDestino);
            copiarFichero = new CopiarFichero(fisCopiar,fosPegar);
        }catch (FileNotFoundException e){
            e.printStackTrace();
        }

    }



    private void cargarVista() {
        frame = new JFrame();
        frame.setBounds(100, 100, 450, 300);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.getContentPane().setLayout(null);

        pbBarraProgreso = new JProgressBar();
        pbBarraProgreso.setBounds(33, 179, 370, 40);
        frame.getContentPane().add(pbBarraProgreso);

        btnBotonCopia = new JButton("HACER COPIA");
        btnBotonCopia.setBounds(33, 128, 150, 40);
        frame.getContentPane().add(btnBotonCopia);

        tfArchivoOrigen = new TextField();
        tfArchivoOrigen.setFont(new Font("Dialog", Font.PLAIN, 16));
        tfArchivoOrigen.setBounds(33, 26, 337, 32);
        frame.getContentPane().add(tfArchivoOrigen);
        tfArchivoOrigen.setBackground(new Color(255, 255, 255));

        tfArchivoDestino = new TextField();
        tfArchivoDestino.setFont(new Font("Dialog", Font.PLAIN, 16));
        tfArchivoDestino.setBounds(33, 90, 337, 32);
        frame.getContentPane().add(tfArchivoDestino);

        JLabel lblDescripcionPrimerTF = new JLabel("Archivo de donde se quiere copiar:");
        lblDescripcionPrimerTF.setFont(new Font("Tahoma", Font.PLAIN, 16));
        lblDescripcionPrimerTF.setBounds(33, 0, 337, 20);
        frame.getContentPane().add(lblDescripcionPrimerTF);

        JLabel lblDescripcionSegundoTF = new JLabel("Archivo donde se copiará:");
        lblDescripcionSegundoTF.setFont(new Font("Tahoma", Font.PLAIN, 16));
        lblDescripcionSegundoTF.setBounds(33, 64, 337, 20);
        frame.getContentPane().add(lblDescripcionSegundoTF);

        lblComprobacion = new JLabel("");
        lblComprobacion.setForeground(new Color(255, 0, 0));
        lblComprobacion.setFont(new Font("Tahoma", Font.PLAIN, 16));
        lblComprobacion.setBounds(33, 226, 370, 26);
        frame.getContentPane().add(lblComprobacion);
    }


}
